diff --git a/pimd/pim6_mld.c b/pimd/pim6_mld.c
index aa39be63dbbb..7423dafaf6ab 100644
--- a/pimd/pim6_mld.c
+++ b/pimd/pim6_mld.c
@@ -431,7 +431,6 @@ static void gm_sg_update(struct gm_sg *sg, bool has_expired)
 
 	} else if (sg->tib_joined && !new_join) {
 		tib_sg_gm_prune(gm_ifp->pim, sg->sgaddr, gm_ifp->ifp, &sg->oil);
-
 		sg->oil = NULL;
 		sg->tib_joined = false;
 	}
diff --git a/pimd/pim_igmpv3.c b/pimd/pim_igmpv3.c
index 15078dd1ecd2..96f97f1d1272 100644
--- a/pimd/pim_igmpv3.c
+++ b/pimd/pim_igmpv3.c
@@ -355,6 +355,7 @@ void igmp_source_delete(struct gm_source *source)
 
 	source_timer_off(group, source);
 	igmp_source_forward_stop(source);
+	source->source_channel_oil = NULL;
 
 	/* sanity check that forwarding has been disabled */
 	if (IGMP_SOURCE_TEST_FORWARDING(source->source_flags)) {
@@ -371,8 +372,6 @@ void igmp_source_delete(struct gm_source *source)
 		/* warning only */
 	}
 
-	source_channel_oil_detach(source);
-
 	/*
 	  notice that listnode_delete() can't be moved
 	  into igmp_source_free() because the later is
diff --git a/pimd/pim_tib.c b/pimd/pim_tib.c
index 6ffea868d804..4081786c1e49 100644
--- a/pimd/pim_tib.c
+++ b/pimd/pim_tib.c
@@ -163,4 +163,6 @@ void tib_sg_gm_prune(struct pim_instance *pim, pim_sgaddr sg,
 	  per-interface (S,G) state.
 	 */
 	pim_ifchannel_local_membership_del(oif, &sg);
+
+	pim_channel_oil_del(*oilp, __func__);
 }
